%define anolis_release 1

Name:        mdadm
Version:     4.3
Release:     %{anolis_release}%{?dist}
Summary:     The mdadm program controls Linux md devices (software RAID arrays)
URL:         http://www.kernel.org/pub/linux/utils/raid/mdadm/
License:     GPLv2+

Source:      https://mirrors.edge.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.xz
Source1:     raid-check
Source2:     mdadm.rules
Source3:     mdadm-raid-check-sysconfig
Source4:     mdmonitor.service
Source5:     mdadm.conf
Source6:     mdadm_event.conf
Source7:     raid-check.timer
Source8:     raid-check.service

# Build without -Werror.
Patch00:     disable-Werror.patch

BuildRequires: make
BuildRequires: systemd-rpm-macros binutils-devel gcc systemd-devel
Requires(post): systemd coreutils
Requires(preun): systemd
Requires(postun): systemd coreutils

%description 
The mdadm program is used to create, manage, and monitor Linux MD (software
RAID) devices.  As such, it provides similar functionality to the raidtools
package.  However, mdadm is a single program, and it can perform
almost all functions without a configuration file, though a configuration
file can be used to help with some common tasks.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
make %{?_smp_mflags} CXFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS" SYSCONFDIR="%{_sysconfdir}" mdadm mdmon

%install
make DESTDIR=%{buildroot} MANDIR=%{_mandir} BINDIR=%{_sbindir} SYSTEMD_DIR=%{_unitdir} UDEVDIR=/usr/lib/udev/ install install-systemd
install -Dp -m 755 %{SOURCE1} %{buildroot}%{_sbindir}/raid-check
install -Dp -m 644 %{SOURCE2} %{buildroot}%{_udevrulesdir}/65-md-incremental.rules
install -Dp -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/raid-check
mkdir -p -m 710 %{buildroot}/run/mdadm

# systemd
mkdir -p %{buildroot}%{_unitdir}
install -m644 %{SOURCE4} %{buildroot}%{_unitdir}
install -m644 %{SOURCE7} %{buildroot}%{_unitdir}
install -m644 %{SOURCE8} %{buildroot}%{_unitdir}

# tmpfile
mkdir -p %{buildroot}%{_tmpfilesdir}
install -m 0644 %{SOURCE5} %{buildroot}%{_tmpfilesdir}/%{name}.conf
mkdir -p %{buildroot}%{_localstatedir}/run/
install -d -m 0710 %{buildroot}/run/%{name}/

# abrt
mkdir -p %{buildroot}/etc/libreport/events.d
install -m644 %{SOURCE6} %{buildroot}/etc/libreport/events.d

%generate_compatibility_deps

%post
%systemd_post mdmonitor.service raid-check.timer
%{_bindir}/systemctl disable mdmonitor-takeover.service  >/dev/null 2>&1 || :

%preun
%systemd_preun mdmonitor.service raid-check.timer

%postun
%systemd_postun_with_restart mdmonitor.service

%files
%dir %{abidir}
%license COPYING
%doc mdadm.conf-example misc/*
%{_udevrulesdir}/*
%{_sbindir}/*
%{abidir}/*-option.list
%{_unitdir}/*
%{_mandir}/man*/md*
/usr/lib/systemd/system-shutdown/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%dir /run/%{name}/
%config(noreplace) %{_tmpfilesdir}/%{name}.conf
/etc/libreport/events.d/*

%changelog
* Tue Mar 18 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 4.3-1
- Update to 4.3 from 4.2

* Tue Oct 18 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 4.2-3
- optimise spec file

* Fri Apr 22 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 4.2-2
- Remove requirement libreport-filesystem

* Tue Mar 08 2022 Jacob Wang <yungao.jacob@linux.alibaba.com> - 4.2-1
- Initial version from upstream 4.2
